package com.ningdatech.pmapi.todocenter.model.dto.req;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

import javax.validation.constraints.NotNull;

import com.ningdatech.basic.model.PagePo;
import com.ningdatech.pmapi.common.enumeration.ExportOptionEnum;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 待办中心-导出查询实体信息
 *
 * @author CMM
 * @since 2023/01/12 16:01
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ReqToBeProcessedExportDTO extends PagePo implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("申报单位名称")
    private String buildUnitName;

    @ApiModelProperty("预算年度")
    private Integer projectYear;

    @ApiModelProperty("流程发起开始时间")
    private LocalDateTime processLaunchStartTime;

    @ApiModelProperty("流程发起结束时间")
    private LocalDateTime processLaunchEndTime;

    @ApiModelProperty(value = "是否增补项目",allowableValues = "非增补项目 0,增补项目 1")
    @NotNull(message = "是否增补字段不能为空!")
    private Integer isSupplement;

    @ApiModelProperty("导出选项")
    @NotNull(message = "导出选项不能为空")
    private List<ExportOptionEnum> exportOptionList;

}
